/*
 *	app.c
 *
 *	̃{l(}`)
 *
 *	* Wed Feb 25 01:23:38 JST 2015 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_SOUND
const void* sound_table[SOUND_COUNT];
#endif /*USE_SOUND*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

#ifdef  USE_SOUND_MANAGER
static void sound_play_stub(int iCh, int iData, int iLoop) {
	if((unsigned)iData >= SOUND_COUNT) { DIE(); }
	sound_play(iCh, sound_table[iData], iLoop);
}
#endif/*USE_SOUND_MANAGER*/

#ifdef  USE_SOUND_MIXER
static void SndMxr_Update() {
	int i;
	unsigned char AttSum[32];
	SndMxr_GetSndChAttAll(pSndMxr,-1,AttSum); //Sق̌ʂ擾
	for(i=0;i<SOUND_MAXCH;i++) {sound_att(i,AttSum[i]);} //Sق̌ʂݒ肷
}
static void SndMxr_TimerProc(void* context) { //Sound Mixerpϊ
	if(sound_stat(1)) {SndMxr_SetMxrChAtt(pSndMxr,4,64, 0,0);} //1ŉoBGMĐȂΤðBGM𑦏          
	else              {SndMxr_SetMxrChAtt(pSndMxr,4, 0,64,5);} //1ŉoBGM~ȂΤðBGM0.5bŕA     {{TODO:عݒ}}
	if(sound_stat(3)) {SndMxr_SetMxrChAtt(pSndMxr,5,64, 0,0);} //3ŴװĐȂΤðBGM,oBGM,SE𑦏 
	else              {SndMxr_SetMxrChAtt(pSndMxr,5, 0, 0,0);} //3Ŵװ~ȂΤðBGM,oBGM,SE𑦕A 
	SndMxr_Exec(pSndMxr); //Sound Mixers
	SndMxr_Update(); //Sق̌ʂݒ肷
}
#endif/*USE_SOUND_MIXER*/

#ifdef  USE_SOUND_SEQUENCER
static int SndSeq_fnLen(int iPhr) {
	return ppd_playback_time(sound_table[iPhr]);
}
static int SndSeq_fnNext(int iPhr) {
	return (iPhr == SND_BGM_1G) || (iPhr == SND_BGM_ST) ? iPhr : -1;
}
static int SndSeq_fnPrev(int iPhr) {
	return (iPhr == SND_BGM_1G) || (iPhr == SND_BGM_ST) ? iPhr : -1;
}
static void SndSeq_fnPan(int iTrk, int iPan) {
	//P/ECEɂ̓XeIĐ͖̂ŁA{֐͎gpȂB
}
static void SndSeq_fnVol(int iTrk, int iVol) {
	SndMxr_SetMxrChAtt(pSndMxr, iTrk, 64-(iVol*64/SndVol_Max), 0, 0);
	SndMxr_Update();
}
static void SndSeq_fnStop(int iTrk) {
	sound_stop(iTrk);
}
static void SndSeq_fnPlay(int iTrk, int iPhr, int iVol, int iPan) {
	sound_play(iTrk, sound_table[iPhr], -1);
	SndMxr_SetMxrChAtt(pSndMxr, iTrk, 64-(iVol*64/SndVol_Max), 0, 0);
	SndMxr_Update();
}
static int SndSeq_fnTime() {
	return pceTimerGetCount(); //ݎ[ms]PʂŕԂB
}
#endif/*USE_SOUND_SEQUENCER*/

#ifdef  USE_EVENT_TIMER
static void EvtTmr_onEvent(int iEvtTmrCh, int iEvent) { //ϗpď֐
	TRACE("%d:%d:%d\n", now / FPS, iEvtTmrCh, iEvent);
}
#endif/*USE_EVENT_TIMER*/

#ifdef  USE_LOG_BUFFER
static int LogBuf_fnDraw(int x, int y, const char* Str) { //عݒ`̕`֐
	render_reduced_string(&render, x, y, Str, 3);
	return 10;
}
#endif/*USE_LOG_BUFFER*/

#ifdef  USE_TCL
//srand seed
static int Tcl_SrandCmd(Tcl_Interp* iPtr) {
	if((iPtr->argc < 1) || (iPtr->argc > 2)) { DIE(); }
	srand((iPtr->argc == 2) ? atoi(iPtr->argv[1]) : time(NULL));
	return TCL_OK;
}
//rand
static int Tcl_RandCmd(Tcl_Interp* iPtr) {
	if(iPtr->argc != 1) { DIE(); }
	iPtr->result = strdup_printf("%d", rand());
	return TCL_OK;
}
//log string
static int Tcl_LogCmd(Tcl_Interp* iPtr) {
	if(iPtr->argc != 2) { DIE(); }
#ifdef  USE_LOG_BUFFER
	LogBuf_Print(pLogBuf, iPtr->argv[1]);
	update();
#else //USE_LOG_BUFFER
	TRACE("%s\n", iPtr->argv[1]);
#endif//USE_LOG_BUFFER
	return TCL_OK;
}
//schedule
static int Tcl_ScheduleCmd(Tcl_Interp* iPtr) {
	if(iPtr->argc != 1) { DIE(); }
	schedule();
	return TCL_OK;
}
#endif//USE_TCL

void
app_init()
{
#ifdef  USE_USBSUSPEND_PROBLEMWORKAROUND
	//uUSBTXyhP/ECEnOAbv鎖Lv鏈ݒ肵܂B
	Intel915G_WindowsXp_UsbSuspend_ProblemWorkaround_init();
#endif//USE_USBSUSPEND_PROBLEMWORKAROUND

	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
//sv	pceLCDDispStart();	//{{2014/12/31폜:cstart.cpceAppInit00()pceLCDDispStart()ĂяoAtʂ̕\Jn悤ɂ܂B}}
#ifdef USE_REPEAT
	pad_set_repeat(REPEAT_PAD, REPEAT_DELAY, REPEAT_INTERVAL);
#endif /*USE_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/
#ifdef USE_RENDF
	surface.zbuff = zbuff;
	rendf_init(&rendf, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#endif /*USE_RENDF*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef USE_RESOURCE
	/* pext@CYt\[X擾܂B */
	resource = resource_address(PRESCAN_STRINGIFY(PROJECT) ".pex");
#endif /*USE_RESOURCE*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_DBG
	/* DBGjbgݒ肵܂B */
	dbg_init();
#endif /*USE_DBG*/

#ifdef GC_LEVEL
	/* K[x[WRN^[܂B */
	gc_init(GC_LEVEL);
#endif /*GC_LEVEL*/

#ifdef BITMAP_GC_UNIT
	/* Bitmap GC܂B */
	BitmapGC_Init(BITMAP_GC_UNIT);
#endif /*BITMAP_GC_UNIT*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#if defined(USE_2BIT_ADPCM) || defined(USE_TRUESPEECH)
	/* - 2-bit ADPCM Decoder,,DSP Group TrueSpeech DecoderƁAyCu𕹗pꍇ́AyCu̎gp`l炷Ƃɂ܂B
	 *   ̑΍sȂƁA`l0gp悤ƂāAnOAbvĂ܂܂B
	 * - 2-bit ADPCM Decoder,,DSP Group TrueSpeech DecoderɌ炸Astream_play()𗘗p@\ƁAyCuƕpꍇ́Al̑΍􂪕KvłB
	 * //{{2015/01/15Rg폜:muslib.cłInitMusic()́umusic_wch = 0;vsȂ悤ɂ̂ŁAǂ̃^C~Omusic_wchύXĂ\܂B
	 * //- music_wchύX鏈́AInitMusic()ōsKv܂B
	 * //  InitMusic()Aumusic_wch = 0;vsĂ邩łBInitMusic()ɕύXƁA0ɖ߂Ă܂܂B
	 * //- Amusic_loudness()̋@\music_wchQƂĂ܂A
	 * //  Al擾Ă̂ŁAmusic_loudness()Ăяomusic_wchύXĂA͂܂B
	 * //}}2015/01/15Rg폜:muslib.cłInitMusic()́umusic_wch = 0;vsȂ悤ɂ̂ŁAǂ̃^C~Omusic_wchύXĂ\܂B */
	music_wch = 3; /* `l0=2-bit ADPCM Decoder,,DSP Group TrueSpeech DecoderA`l1-2=AvP[VgpA`l3=yCuƂ */
#endif /*defined(USE_2BIT_ADPCM) || defined(USE_TRUESPEECH)*/
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

#ifdef USE_2BIT_ADPCM
	/* 2-bit ADPCM DecoderN܂B */
	adpcm_init(SOUND_MAXCH);
#endif /*USE_2BIT_ADPCM*/

#ifdef USE_TRUESPEECH
	/* DSP Group TrueSpeech DecoderN܂B */
	TrueSpeech_Init(SOUND_MAXCH);
#endif /*USE_TRUESPEECH*/

	/* TEh܂B */
#ifdef USE_SOUND
	{
#define SOUND_(name) { extern const unsigned char name[]; sound_table[SND_##name] = name; }
#define SOUND_RESOURCE_(name,fname) { sound_table[SND_##name] = fpk_address(resource, fname, NULL); }
#include "sound.h"
#undef SOUND_
#undef SOUND_RESOURCE_
	}
#endif /*USE_SOUND*/

	/* Sound Manager܂B */
#ifdef  USE_SOUND_MANAGER
	{
		static const ST_SndMgrInfo stSndMgrInfo = { sound_play_stub, sound_stop, sound_stat, sound_att };
		pSndMgrBgm = SndMgr_Init(&stSndMgrInfo, SOUND_MANAGER_BGM_MINCH, SOUND_MANAGER_BGM_MAXCH); /* BGM Sound Manager */
		pSndMgrSe1 = SndMgr_Init(&stSndMgrInfo, SOUND_MANAGER_SE1_MINCH, SOUND_MANAGER_SE1_MAXCH); /* SE1 Sound Manager */
		pSndMgrSe2 = SndMgr_Init(&stSndMgrInfo, SOUND_MANAGER_SE2_MINCH, SOUND_MANAGER_SE2_MAXCH); /* SE2 Sound Manager */
	}
#endif/*USE_SOUND_MANAGER*/

	/* Sound Mixer܂B */
#ifdef  USE_SOUND_MIXER
	{
		static const int TBL_SndMxr_SndChMask[] = { //Ͻz
			(1<<0),               //Sound Mixer0:ׯ0(޼ݻɂحюw)         
			(1<<1),               //Sound Mixer1:ׯ1(޼ݻɂحюw)         
			(1<<2),               //Sound Mixer2:ׯ2(޼ݻɂحюw)         
			(1<<3),               //Sound Mixer3:ׯ3(޼ݻɂحюw)         {{TODO:عݒ}}
			(1<<0),               //Sound Mixer4:oBGMĐΏ:ðBGM            
			(1<<0)|(1<<1)|(1<<2), //Sound Mixer5:װĐΏ  :ðBGM,oBGM,SE 
			-1};                  //Sound Mixer6:İح           :S         
		pSndMxr = SndMxr_Init(ARRAY_SIZE(TBL_SndMxr_SndChMask), TBL_SndMxr_SndChMask); //Sound Mixer쐬
		timer_start(100, SndMxr_TimerProc, NULL); //Sound MixerpϊJn
	}
#endif/*USE_SOUND_MIXER*/

	/* TEhV[PT܂B */
#ifdef  USE_SOUND_SEQUENCER
	{
		static const ST_SndSeqInfo stSndSeqInfo = { &SndSeq_fnTime, &SndSeq_fnPlay, &SndSeq_fnStop, &SndSeq_fnVol, &SndSeq_fnPan, &SndSeq_fnLen, &SndSeq_fnNext, &SndSeq_fnPrev };
		SndSeq_Init(&stSndSeqInfo);
		timer_start(10, SndSeq_Exec, NULL); //޼ݻpϊJn
	}
#endif/*USE_SOUND_SEQUENCER*/

	/* Cxg^C}܂B */
#ifdef  USE_EVENT_TIMER
	{
		static const uint16_t TBL_EvtTmr_Data0[]={//#0ް
			SEC(0),10, //Jnɤޔԍ(10)s
			SEC(2),11, // 2b҂Ĥޔԍ(11)s
			SEC(1),12, // 1b҂Ĥޔԍ(12)s
			SEC(0),13, //̌シޔԍ(13)s
			SEC(3),-1};// 3b҂Ĥ擪ٰ߂
		static const uint16_t TBL_EvtTmr_Data1[]={//#1ް
			SEC(9),20, // 9b҂Ĥޔԍ(20)s
			SEC(0), 0};//̌シI
		static const uint16_t* const TBL_EvtTmr_Data[]={//eقް
			TBL_EvtTmr_Data0, //#0ް
			TBL_EvtTmr_Data1};//#1ް
		pEvtTmr=EvtTmr_Init(ARRAY_SIZE(TBL_EvtTmr_Data),TBL_EvtTmr_Data,EvtTmr_onEvent);//ς
	}
#endif/*USE_EVENT_TIMER*/

	/* ėpJE^Ǘ܂B */
#ifdef  USE_COUNTER_MANAGER
	pCntMgr = CntMgr_Init(COUNTER_MAXCH);
#endif/*USE_COUNTER_MANAGER*/

	/* Oobt@܂B */
#ifdef  USE_LOG_BUFFER
	pLogBuf = LogBuf_Init((DISP_Y+9)/10, LogBuf_fnDraw);
#endif/*USE_LOG_BUFFER*/

#ifdef  USE_TCL
	//TclC^v^邽߂ɁAIɃK[x[WRNVsB
#if     defined(GC_LEVEL)
/*K{*/timer_start(500/**/, gc_run, NULL);//cliptcl.c̃RgQƁBʏGCTclC^v^gpꍇ́A̍ssȂƋɒ[ɒxȂB
#elif   defined(BITMAP_GC_UNIT)
//C	timer_start(500/**/, gc_run, NULL);//cliptcl.c̃RgQƁBBitmap GCgpꍇ͋ɒ[ɒx͂ȂA̍ssł͂B
#else //defined(GC_LEVEL)||defined(BITMAP_GC_UNIT)
	#error TclC^v^̓K[x[WRN^[̕pK{łB
#endif//defined(GC_LEVEL)||defined(BITMAP_GC_UNIT)
	//TclC^v^쐬B
	iPtr = Tcl_CreateInterp();
	//ėpIȃAvP[V`̃R}ho^B
	Tcl_CreateCommand(iPtr, "srand",    Tcl_SrandCmd,    NULL);
	Tcl_CreateCommand(iPtr, "rand",     Tcl_RandCmd,     NULL);
	Tcl_CreateCommand(iPtr, "log",      Tcl_LogCmd,      NULL);
	Tcl_CreateCommand(iPtr, "schedule", Tcl_ScheduleCmd, NULL);
#endif//USE_TCL

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#define TEXTURE_RESOURCE_(name,fname) const void* const name = fpk_address(resource, fname, NULL);
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#define TEXTURE_RESOURCE_(name,fname) name,
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef USE_VIDREC
	/* ʏo͂܂B */
	yield(); /* runŎsꍇ̎smFɉ邽߁AUSB@\̐؂ւ͂ɒx点 */
#ifdef LDIRECT_INTERVAL
	cdcacm_start(0, sizeof vbuff / 2, NULL, NULL);
#else /*LDIRECT_INTERVAL*/
	cdcacm_start(0, sizeof vbuff / 4, NULL, NULL);
#endif /*LDIRECT_INTERVAL*/
#endif /*USE_VIDREC*/

#ifdef  USE_TASK
	/* ^XNXPW[܂B
	 * - AChXbhƕpꍇ́Aidle_proc()̒ŏĂB
	 *   AChXbhƕp@́Atask_yield()[note]QƂĂB */
	task_init(INT_MIN);//{{TODO:ѱ̎sDxͱعݒ}}
#endif/*USE_TASK*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
/*{{AvP[VL̃N[Abv*/
	/** no job **/
/*}}AvP[VL̃N[Abv*/

#ifdef USE_VIDREC
	/* ʏo͂I܂B */
	cdcacm_stop();
#endif /*USE_VIDREC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef BITMAP_GC_UNIT
	/* Bitmap GC܂B */
	BitmapGC_Free();
#endif /*BITMAP_GC_UNIT*/

#ifdef GC_LEVEL
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*GC_LEVEL*/

#ifdef USE_DBG
	/* DBGjbg̐ݒ܂B */
	dbg_free();
#endif /*USE_DBG*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/

#ifdef  USE_USBSUSPEND_PROBLEMWORKAROUND
	//uUSBTXyhP/ECEnOAbv鎖Lv鏈܂B
	Intel915G_WindowsXp_UsbSuspend_ProblemWorkaround_free();
#endif//USE_USBSUSPEND_PROBLEMWORKAROUND
}

/****************************************************************************
 *	update
 ****************************************************************************/

/* * Mon Mar 10 13:29:56 JST 2008 Naoyuki Sawa
 * - update()AʍXV𕪗A܂B
 */
#ifdef V_SCREEN
/* vbuff(c)_def_vbuff()ϊ */
//static void rotate_screen() {
//	unsigned char *src = &vbuff[88 - 1];	/* ]̉ʂ͍ォ瑖Jn܂ */
//	unsigned char *dst = &_def_vbuff[0];	/* ]̏cʂ͉Eォ瑖Jn܂ */
//	int x = 88;
//	do {
//		int y = 128;
//		do {
//			*dst++ = *src;		/* ʂEɑ܂ */
//			src += 88;		/* cʂɑ܂ */
//		} while(--y);
//						/* ʂ͊Ɏ̍sֈړĂ܂ */
//		src -= 88 * 128 + 1;		/* cʂ̗̈ԏֈړ܂ */
//	} while(--x);
//}
// (C = 9.2ms/1call  ASM = 3.2ms/1call)
/*static*/ void rotate_screen();
asm("
	.code
	.align	1
rotate_screen:
	xld.w	%r12, 0x0e00			; %r12 := FRAM4_START
	xld.w	%r13, rotate_screen_DOX		; %r13 := DOY
	xld.w	%r14, rotate_screen_END		; %r14 := END
	xcall.d	memcpy				; %r10 := FRAM4_START = memcpy(FRAM4_START, DOX, END - DOX)
	sub	%r14, %r13			; %r14 := END - DOY			*delay*
	xld.w	%r4, vbuff+87			; %r4  := src = &vbuff[88 - 1]
	xld.w	%r5, _def_vbuff			; %r5  := dst = &_def_vbuff[0]
	xld.w	%r6, 88				; %r6  := 88
	xld.w	%r7, 128			; %r7  := 128
	xld.w	%r11, 11265			; %r11 := 88 * 128 + 1
	ld.w	%r12, %r6			; %r12 := x = 88
	jp	%r10				; goto FRAM4_START			(jp.d͕s!!)
;//{{FRAM4̈֓]
rotate_screen_DOX:				; do {
	ld.w	%r13, %r7			;   %r13 := y = 128
rotate_screen_DOY:				;   do {
	ld.ub	%r9, [%r4]			;     %r9  := c = *src
	sub	%r13, 1				;     %r13 := --y			*anti-interlock*
	ld.b	[%r5]+, %r9			;     %r5  := *dst++ = c
	jrne.d	rotate_screen_DOY		;   } while(--y)
	add	%r4, %r6			;     %r4  := src += 88			*delay*
	sub	%r12, 1				;   %r12 := --x
	jrne.d	rotate_screen_DOX		; } while(--x)
	sub	%r4, %r11			;   %r4  := src -= 88 * 128 + 1		*delay*
	ret
rotate_screen_END:
;//}}܂FRAM4̈֓]
");
#endif /*V_SCREEN*/

/* * Mon Nov 06 17:37:17 JST 2006 Naoyuki Sawa
 * - schedule()AʍXV𕪗܂B
 *   t[҂ʍXVsꍇ́Å֐ĂяoĂB
 * * Thu Dec 21 21:17:56 JST 2014 Naoyuki Sawa
 * - Oobt@`A܂łschedule()ōsĂ܂Aupdate()ōs悤ɕύX܂B
 *   ɉāAOobt@`OŁAzVRAMۑ悤ɂ܂B
 *   ̕ύXɂāAAvP[V́AOobt@`̉e𖳎āAI[o[CƌȂ悤ɂȂ܂B
 *   ȉ̂悤ȏ\ƂȂ܂B
 *   1
 *   void app_main(){
 *     surface_clear(&surface,0);
 *     render_ellipse(&render,0,0,DISP_X,DISP_Y,3);//~`悷
 *     for(;;){
 *       schedule();//~j󂹂۸ޯ̧`݂̂۰قł
 *       LogBuf_Printf(pLogBuf,"%d",now);
 *   } }
 *   2
 *   void test(){
 *     //``
 *     LogBuf_Printf(pLogBuf,"some message");
 *     update();//۸ޯ̧`݂̂XV
 *     //``
 *   } }
 * - ̕ύXɔAOobt@`悪A^ƁAPC̉ʃLv`Ɋ܂܂ȂȂƂɁAӂĂB
 *   ^schedule()̒vidrec()ŁCLv`schedule()̒yield()ōs鏈łB
 *   vidrec()yield()Ă΂鎞_ł́AzVRAM͕ĂAOobt@`͎cĂȂłB
 *   Oobt@`́AɃeXĝ߂̕\ł̂ŁA^Lv`Ɋ܂܂ĂȂĂ肪Ǝv܂A
 *   Kvłꍇ́A֐̍ṒAzVRAM𕜌鏈폜΁AύXOƓlɊ܂܂悤ɂł܂B
 */
void
update()
{
#ifdef  USE_LOG_BUFFER
	/* Oobt@`OɉzVRAMޔB */
    #ifdef  V_SCREEN
	static unsigned char tmpbuf[sizeof vbuff];	//Oobt@Əcʂ𕹗pꍇ́AzVRAMޔꎞIȃobt@Ƃ_def_vbuffgȂBrotate_screen()_def_vbuffj󂷂邩łBtmpbuf[]̕gpʂ邱ƂɒӂB
	memcpy(tmpbuf, vbuff, sizeof vbuff);
    #else //V_SCREEN
	memcpy(_def_vbuff, vbuff, sizeof vbuff);	//Oobt@Əcʂ𕹗pȂꍇ́AzVRAMޔꎞIȃobt@Ƃ_def_vbuffgB
    #endif//V_SCREEN
	/* Oobt@`B */
	LogBuf_Draw(pLogBuf, 0, 0);
#endif/*USE_LOG_BUFFER*/

#ifdef V_SCREEN
	rotate_screen();
#endif /*V_SCREEN*/

	/* ʓ] */
	pceLCDTrans();

#ifdef  USE_LOG_BUFFER
	/* Oobt@`OɑޔzVRAM𕜌B */
    #ifdef  V_SCREEN
	memcpy(vbuff, tmpbuf, sizeof vbuff);		//Oobt@Əcʂ𕹗pꍇ
    #else //V_SCREEN
	memcpy(vbuff, _def_vbuff, sizeof vbuff);	//Oobt@Əcʂ𕹗pȂꍇ
    #endif//V_SCREEN
#endif/*USE_LOG_BUFFER*/
}

/****************************************************************************
 *	vidrec
 ****************************************************************************/

#ifdef USE_VIDREC
static void
vidrec()
{
#ifdef LDIRECT_INTERVAL
	static const unsigned char hdr[4] = { DISP_X,DISP_Y,4/*[bpp]*/,FPS };
#else /*LDIRECT_INTERVAL*/
	static const unsigned char hdr[4] = { DISP_X,DISP_Y,2/*[bpp]*/,FPS };
#endif /*LDIRECT_INTERVAL*/
	static int active;
	//
	unsigned char buf[128/**/]; /* (sizeof vbuff)/ÑTCYƂ邱 */
	const unsigned char* src;
	unsigned char* dst;

	if(cdcacm_recv(buf, 1) > 0) {
		switch(buf[0]) {
		case 0:
			active = 0; /* ʏo͒~ */
			break;
		case 1:
			active = 1; /* ʏo͊Jn */
			src = hdr;
			do {
				if(pcePadGetDirect() & PAD_SELECT) {
					exit(0); /* M҂Ɋ荞ŋI */
				}
				src += cdcacm_send(src, &hdr[sizeof hdr] - src);
			} while(src < &hdr[sizeof hdr]);
			break;
		}
	}
	if(active) {
		src = vbuff;
		do {
			dst = buf;
			do {
#ifdef LDIRECT_INTERVAL
				*dst++ = src[0]|(src[1]<<4); 
				src += 2;
#else /*LDIRECT_INTERVAL*/
				*dst++ = src[0]|(src[1]<<2)|(src[2]<<4)|(src[3]<<6);
				src += 4;
#endif /*LDIRECT_INTERVAL*/
			} while(dst < &buf[sizeof buf]);
			dst = buf;
			do {
				if(pcePadGetDirect() & PAD_SELECT) {
					exit(0); /* M҂Ɋ荞ŋI */
				}
				dst += cdcacm_send(dst, &buf[sizeof buf] - dst);
			} while(dst < &buf[sizeof buf]);
		} while(src < &vbuff[sizeof vbuff]);
	}
}
#endif /*USE_VIDREC*/

/****************************************************************************
 *	schedule
 ****************************************************************************/

/* * Fri Dec 15 00:49:15 JST 2006 Naoyuki Sawa
 * - schedule()֐ɁATEh|[YΉR[hǉ܂B
 *   ł͏肭삵Ă悤łAX[v̕Aɖ肪NȂmFłB
 * - A|[YԂ̂܂܁AȂ킿ATEh|[YԂ̂܂܂ŃAvP[VIĂ܂ꍇɂA
 *   CLiPCupceAppExit()pceWaveStop(1)ĂяoĂATEhԂZbĝŁAvłB
 */

void
schedule()
{
#ifdef  USE_EVENT_TIMER
	/* Cxg^C}B */
	EvtTmr_Exec(pEvtTmr);
#endif/*USE_EVENT_TIMER*/

#ifdef  USE_COUNTER_MANAGER
	/* ėpJE^ǗB */
	CntMgr_Exec(pCntMgr);
#endif/*USE_COUNTER_MANAGER*/

#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		/*{{2006/12/15:TEh|[YΉ*/
		int sound_pause = 0/*x}*/;
		/*}}2006/12/15:TEh|[YΉ*/
		int x, y;
		for(;;) {
#endif /*USE_PAUSE*/

			/* ʍXVB */
			update();

#ifdef USE_VIDREC
			/* ʏóB */
			vidrec();
#endif /*USE_VIDREC*/

#ifdef  USE_SOUND_MANAGER
			/* Sound ManagerB */
			SndMgr_Exec(pSndMgrBgm); /* BGM Sound Manager */
			SndMgr_Exec(pSndMgrSe1); /* SE1 Sound Manager */
			SndMgr_Exec(pSndMgrSe2); /* SE2 Sound Manager */
#endif/*USE_SOUND_MANAGER*/

#ifdef USE_IDLE
			/* ACh+VXeB */
			idle_yield();
#else /*USE_IDLE*/
			/* VXeB */
			yield();
#endif /*USE_IDLE*/

			/* pbhԍXVB */
			joy = pad_get();
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

//			/* SELECT{^ꂽIB */ /* AvP[VɂĕsvȂ΁A2s폜ĂB */
//			if(joy & TRG_SELECT) exit(EXIT_SUCCESS); /* AvP[VɂĕsvȂ΁A2s폜ĂB */

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					sound_pause = fINT_EDMA.EHDM1;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 0;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 1;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;
			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE*/

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	EquipDraw
 ****************************************************************************/
//eCɂāAǂ̃}XNw肳Ă`悷邩̑Ή\
static const unsigned char TBL_Layer[]={
	BIN8(01000),	//O	0	ߕ̍,ȎiȂ	   D 
	BIN8(01000),	//	1	r				   D 
	BIN8(10000),	//	2	ߕ,̎Ȃ		    E
	BIN8(00100),	//	3	f				  C  
	BIN8(00010),	//	4	ߕ̉E,E̎Ȃ	 B   
	BIN8(00010),	//	5	Er				 B   
	BIN8(00001),	//	6	̑iȂ		A    
};			//	C					}XN
/*--------------------------------------------------------------------------*/
typedef struct _ST_Item {
	int	wno;
	char*	name;
} ST_Item;
/*--------------------------------------------------------------------------*/
//RX`[ (ɁAp[Abv)
static const ST_Item TBL_ItemCostume[]={
{ 0,"Ȃ"		},// 0
{15,""		},// 1
{16,"킢m"	},// 2
{17,"ToHeart"	},// 3
{18,"p[X[c"	},// 4
{19,"̑"		},// 5
{20,"XN["	},// 6
{21,"rLj̐"	},// 7
{22,"eXgX[c"	},// 8
{23,"hX"		},// 9
{24,"F"		},//10
{25,"̃hX"	},//11
{26,"Ch"		},//12
{27,"lR"	},//13
{28,"̐"	},//14
{29,"j̊w"	},//15
{ 0,"Ȃ"	},//16
};
#define SIZE_ItemCostume ARRAY_SIZE(TBL_ItemCostume)
/*--------------------------------------------------------------------------*/
//莝 (ɁAfNX^eBAbv)
static const ST_Item TBL_ItemHand[]={
{ 0,"Ȃ"		},// 0
{47,"bv"		},// 1
{ 1,"|ڂ"		},// 2
{ 2,"|@"		},// 3
{ 3,""		},// 4
{ 4,"P"		},// 5
{ 5,"P"		},// 6
{ 6,"q"		},// 7
{ 7,"|VFbg"	},// 8
{ 8,"͂肹"		},// 9
{ 9,"lRO[u"	},//10
{11,"̂"	},//11
{12,"̃O[u"	},//12
{13,"uۂ̃}CN"	},//13
{14,"@̃XebL"	},//14
};
#define SIZE_ItemHand ARRAY_SIZE(TBL_ItemHand)
/*--------------------------------------------------------------------------*/
//i (ɁACeWFXAbv)
static const ST_Item TBL_ItemOther[]={
{ 0,"Ȃ"		},// 0
{30,"̃}g"	},// 1
{31,"H"		},// 2
{32,"j[\bNX"	},// 3
{33,"̃}g"	},// 4
{34,"H"		},// 5
{10,"ԂhZ"	},// 6
{35,"\bNX"	},// 7
{36,"fGȃKl"	},// 8
{37,"Xq"	},// 9
{38,"lR~~"		},//10
{39,"Gv"		},//11
{40,"qq̃Kl"	},//12
{41,"ڍ̖Xq"	},//13
{42,"~B̃{"	},//14
{43,"Jnp"	},//15
{44,"Չ̃CJ"	},//16
{45,"ZIZT["	},//17
{46,"_V̈"		},//18
};
#define SIZE_ItemOther ARRAY_SIZE(TBL_ItemOther)
/*--------------------------------------------------------------------------*/
static int EquipDrawSub(int i, int wno) {
	extern const unsigned char IT_FPK[], IT_LST[];
	unsigned char buf[20+(((28+7)&~7)*44)/8*(2+1)];	//WJobt@B1KBȂ̂ŃX^bNɎĂSB
	char fname[16];
	const void* bpe;
	TEXTURE tex;
	if(!i && !wno) { return 0; }	//
	//t@C݂Ȃ0ԂB
	if(!(IT_LST[wno] & (1<<i))) { return 0; }
	//t@C쐬B
	sprintf(fname, "it%d%03d.bpe", i, wno);
	//t@CpbNf[^̒̃t@C̃AhX擾B
	bpe = fpk_address(IT_FPK, fname, NULL);
	//t@CBPEkꂽPGDȂ̂œWJB
	if(BytePairEncodingDecoder_Decode(bpe, buf, sizeof buf) != sizeof buf) { DIE(); }
	//eNX`wb_āAeNX`ɐݒ肷B
	render.context->texture = texture_init(&tex, buf);
	//eNX`ʂ̒ɕ`B
	render_object(&render, 30,54, 0,0,28,44, DRW_NOMAL);
	//t@C`1ԂB
	return 1;
}
/*--------------------------------------------------------------------------*/
static void EquipDraw(int mask, int iItemCostume, int iItemHand, int iItemOther) {
	int i, wno;
	for(i = 6; i >= 0; i--) {
		if(!(TBL_Layer[i] & mask)) { continue; }
		//
		wno = TBL_ItemCostume[iItemCostume].wno;
		if(!EquipDrawSub(i, wno)) {		//ACeŗL̃OBbNA
			if((i == 1) || (i == 5)) {	//r(1),,Er(5)̃CȂ΁c
				EquipDrawSub(i, 0);	//ftHg̃OtBbN`B
			}
		}
		//莝
		wno = TBL_ItemHand[iItemHand].wno;
		EquipDrawSub(i, wno);			//ACeŗL̃OBbN`B
		//i
		wno = TBL_ItemOther[iItemOther].wno;
		if(!EquipDrawSub(i, wno)) {		//ACeŗL̃OBbNA
			if(i == 3) {			//f(3)̃CȂ΁c
				EquipDrawSub(i, 0);	//ftHg̃OtBbN`B
			}
		}
	}


}
/****************************************************************************
 *	app_main
 ****************************************************************************/
//ep[cƁAST_Game.mask̃rbg}XNƂ̑Ή
#define MASK_A		(1<< 0)
#define MASK_B		(1<< 2)
#define MASK_C		(1<< 6)
#define MASK_D		(1<< 8)
#define MASK_E		(1<<12)
#define MASK_ALL	(MASK_A|MASK_B|MASK_C|MASK_D|MASK_E)
//
#define TIME_UNIT	3		//c莞ԕ\ƁAST_Game.timeƂ̔䗦
#define INIT_TIME	(60*TIME_UNIT)	//1Q[̎
#define STOP_TIME_BASE	SEC(0.5)	//{^̒~ԁB̊ԁAԂ͌邪s\ɂȂB	AłLɂȂȂ悤ɂ邽߁B
#define STOP_TIME_RAND	SEC(0.25)	//{^̒~ԂɃ_ŉZ鎞			eՂɃ^C~OȂ悤ɂ邽߁B
//Q[Ǘ\
typedef struct _ST_Game {
	int	cursor;		//J[\ʒu(0`15)
	int	mask;		//_ʒũrbg}XN(b0=A,b2=B,b6=C,b8=D,b12=E)
	int	item[3];	//[0]=RX`[(0`15),[1]=莝(0`14),[2]=i(0`18)
	int	time;		//c莞
} ST_Game;
static ST_Game stGame;
/*--------------------------------------------------------------------------*/
static void game_draw(int playing) {
	int i;
	//wi`B
	sprite_draw(0, 0, SPR_BG, 0);
	//_`B
	for(i = 0; i < 16; i++) {
		if(stGame.mask & (1 << i)) {
			sprite_draw(0, 0, SPR_A1 + i, 0);
		}
	}
	//Q[Ȃ΁c
	if(playing) {
		//J[\𖾂邭`B
		sprite_draw(0, 0, SPR_A0 + stGame.cursor, 0);
		//_ʒuɑΉp[c`B
		i = 0;
		if(stGame.mask & MASK_A) { i |= (1<<0); }
		if(stGame.mask & MASK_B) { i |= (1<<1); }
		if(stGame.mask & MASK_C) { i |= (1<<2); }
		if(stGame.mask & MASK_D) { i |= (1<<3); }
		if(stGame.mask & MASK_E) { i |= (1<<4); }
		EquipDraw(i, stGame.item[0], stGame.item[1], stGame.item[2]);
		//c莞Ԃ`B
		i = (stGame.time + (TIME_UNIT - 1)) / TIME_UNIT;
		render_font(&render, 40, 120, '0' + (i / 10), 2, 0);
		render_font(&render, 45, 120, '0' + (i % 10), 2, 0);
	//Q[łȂ΁c
	} else {
		//J[\Â߂ɕ`B
		sprite_draw(0, 0, SPR_A1 + stGame.cursor, 0);
		//_ʒuɑΉp[c͕`ȂB
		//c莞Ԃ͕`ȂB
	}
}
/*--------------------------------------------------------------------------*/
void app_main() {
	int i;
	do {
		stGame.cursor = RND16(seed) & 15;	//ÑJ[\̏ʒu_Ɍ肷B
		i = (1 << stGame.cursor);
	} while(i & MASK_ALL);			//Ap[cʒu͔B
	for(;;) {
L_DEMO:		//--- f ---
		sound_play(0, sound_table[SND_SE_UI], 1);		//Ch.0
		i = 0;	//_Ń^C~OZbgB
		for(;;) {
			schedule();
			game_draw(0);
			if(i++ % SEC(1.0) < SEC(0.5)) {
				render_string_framed(&render, 18, 72, "PRESS A BUTTON", 2, 0x330);	//_
			}
			//{^ꂽ甲B
			if(joy & TRG_AB) { break; }
			//SELECT{^ꂽIB
			if(joy & TRG_SELECT) { exit(EXIT_SUCCESS); }
			RND16(seed);	//XV
		}
		sound_play(0, sound_table[SND_SE_START], 1);		//Ch.0
		//--- Q[Jn ---
		//stGame.cursor = p
		stGame.mask = 0;
		stGame.item[0] = RND16(seed) % SIZE_ItemCostume;
		stGame.item[1] = RND16(seed) % SIZE_ItemHand;
		stGame.item[2] = RND16(seed) % SIZE_ItemOther;
		stGame.time = INIT_TIME;
		i = SEC(1.0) + (RND16(seed) % SEC(0.5));	//Jñ^C~O点Ȃ悤ɁA1.0`1.5b̃_ŊJnȎ҂Ԃ肷B
		do {
			schedule();
			game_draw(1);
			//SELECT{^ꂽfɖ߂B
			if(joy & TRG_SELECT) { goto L_DEMO; }
		} while(--i);
		//--- Q[ ---
		for(;;) {
			schedule();
			game_draw(1);
			//SELECT{^ꂽfɖ߂B
			if(joy & TRG_SELECT) { goto L_DEMO; }
			//{^ꂽ
			if(joy & TRG_AB) {
				i = (1 << stGame.cursor);
				//p[cʒuȂ΁c
				if(i & MASK_ALL) {
					//܂_ĂȂ΁c
					if(!(i & stGame.mask)) {
						sound_play(1, sound_table[SND_SE_HIT], 1);	//Ch.1
						//_B
						stGame.mask |= i;
						//SẴp[c_AB
						if(stGame.mask == MASK_ALL) { break; }
					} else {
						sound_play(1, sound_table[SND_SE_MISS], 1);	//Ch.1
					}
				//p[cʒułȂ΁c
				} else {
					sound_play(1, sound_table[SND_SE_MISS], 1);		//Ch.1
				}
				//~Ԃ肷B
				i = STOP_TIME_BASE + (RND16(seed) % STOP_TIME_RAND);
				do {
					if(stGame.time) { stGame.time--; }	//~Ԃ͌B
				    //	if(!stGame.time) { break; }	˒~ɐԂȂɑLZƑ슴ǂȂ̂ł̍s̓RgAEgB
					schedule();
					game_draw(1);
					//SELECT{^ꂽfɖ߂B
					if(joy & TRG_SELECT) { goto L_DEMO; }
				} while(--i);
			}
			//J[\i߂B
			stGame.cursor = (stGame.cursor + 1) & 15;
			sound_play(0, sound_table[SND_SE_CURSOR], 1);				//Ch.0
			//Ԃ炷B
			if(stGame.time) { stGame.time--; }
			//ԂȂc
			if(!stGame.time) {
				i = (1 << stGame.cursor);
				//p[cʒułȂ΁AQ[I[o[ƂB
				//p[cʒuɃJ[\LԂŃQ[I[o[ɂƁA킵B
				if(!(i & MASK_ALL)) { break; }
			}
		}
		//--- Q[I ---
		//Ȃ΁c
		if(stGame.mask == MASK_ALL) {
			sound_play(0, sound_table[SND_SE_CLEAR], 1);				//Ch.0
			//3bԊ}`BLZsB
			for(i = 0; i < SEC(3.0); i++) {
				schedule();
				game_draw(1);
				render_string_framed(&render, 0,  0, TBL_ItemCostume[stGame.item[0]].name, 0, 0x330);
				render_string_framed(&render, 0, 10, TBL_ItemHand[   stGame.item[1]].name, 0, 0x330);
				render_string_framed(&render, 0, 20, TBL_ItemOther[  stGame.item[2]].name, 0, 0x330);
				//SELECT{^ꂽfɖ߂B
				if(joy & TRG_SELECT) { goto L_DEMO; }
			}
			//10bԃNA\sBLZB
			for(i = 0; i < SEC(10.0); i++) {
				schedule();
				game_draw(1);
				render_string_framed(&render, 0,  0, TBL_ItemCostume[stGame.item[0]].name, 0, 0x330);
				render_string_framed(&render, 0, 10, TBL_ItemHand[   stGame.item[1]].name, 0, 0x330);
				render_string_framed(&render, 0, 20, TBL_ItemOther[  stGame.item[2]].name, 0, 0x330);
				if(i % SEC(1.0) < SEC(0.5)) {
					render_string_framed(&render, 32, 72, "CLEAR!", 2, 0x330);	//_
				}
				if(joy & TRG_AB) { break; }
				//SELECT{^ꂽfɖ߂B
				if(joy & TRG_SELECT) { goto L_DEMO; }
			}
		//sȂ΁c
		} else {
			//10bԃQ[I[o[\sB0.5bォLZB
			for(i = 0; i < SEC(10.0); i++) {
				schedule();
				game_draw(1);
				if(i % SEC(1.0) < SEC(0.5)) {
					render_string_framed(&render, 26, 72, "GAME OVER", 2, 0x330);	//_
				}
				if(i >= SEC(0.5)) {
					if(joy & TRG_AB) { break; }
				}
				//SELECT{^ꂽfɖ߂B
				if(joy & TRG_SELECT) { goto L_DEMO; }
			}
		}
	}
}
